/* 
 * File:   LinkedList.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Header file for a LinkedList. It is the means to access ListNodes that store
 * strings.
 *
 * Based on earlier LinkedList, which was created on January 11, 2013, 3:32 PM
 */

#ifndef LINKEDLIST_H
#define	LINKEDLIST_H

#include <iostream>
#include "ListNode.h"

class LinkedList {
public:
    //big three
    LinkedList();//default constructor
    LinkedList(const LinkedList& orig);//copy constructor (not defined)
    virtual ~LinkedList();//virtual destructor (not defined)
    
    //public utilities
    void append(std::string in);//add a line at the end
    void remove(int index);//delete a line by its index
    void insert(std::string in, int index);//insert a line at an index
    int count();//count the stored lines
    //display entire contents (specify indexing)
    void showAllLines(std::string lprefix, int lindex);
    //displays contents in a range (specify indexing)
    void showLines(std::string lprefix, int lindex, int lbegin, int lend);
    //stream the entire contents
    friend std::ostream& operator<<(std::ostream& output, LinkedList& list);
private:
    ListNode* _head;//start of the train
};

#endif	/* LINKEDLIST_H */

