/* 
 * File:   TreeNode.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * A node of a Tree. Holds a string.
 * 
 * Derived from existing work by:
 * Mary K. Vernon (University of Wisconsin-Madison)
 * http://pages.cs.wisc.edu/~vernon/cs367/notes/9.BST.html
 *
 * Created on March 7, 2013, 5:28 PM
 */

#ifndef TREENODE_H
#define	TREENODE_H

#include <string>

class TreeNode {
public:
    //big three
    //constructor for pseudoNodes/roots
    TreeNode();
    //constructor for normal use (if root, make 'parent' null)
    TreeNode(std::string key, TreeNode* left,
            TreeNode* right, TreeNode* parent, bool rightSpawn);
    TreeNode(const TreeNode& orig);//copy constructor (not defined)
    virtual ~TreeNode();//virtual destructor (not defined)
    
    //accessors
    std::string getKey();
    TreeNode* getLeft();
    TreeNode* getRight();
    TreeNode* getParent();
    bool isRightSpawn();
    
    //mutators
    void setKey(std::string key);
    void setLeft(TreeNode* left);
    void setRight(TreeNode* right);    
    void setParent(TreeNode* parent);
    void setRightSpawn(bool rightSpawn);
private:
    //the string the node holds
    std::string _key;
    //pointers to "left" and "right" nodes
    TreeNode* _left;
    TreeNode* _right;
    //pointer to the parent node (mostly for display purposes)
    TreeNode* _parent;
    //whether it's a "right" child
    bool _rightSpawn;
};

#endif	/* TREENODE_H */

